-- get the addon namespace
local addon, ns = ...

-- get the config values
local cfg = ns.cfg

-- get the library
local lib = ns.lib

lib.classes["PALADIN"] = {}
lib.classes["PALADIN"][2] = function () --Protection
	lib.SetAltPower(SPELL_POWER_HOLY_POWER,HOLY_POWER_COST,nil,function()
	if lib.GetAura({"DivPurp"})>0 and cfg.AltPower.now<3 then
		lib.ComboSet(3)
	end
	end)
	lib.AddAura("DivPurp",90174,"buff","player") -- Divine Purpose
	lib.SetAuraFunction("DivPurp","OnApply",function()
		if cfg.AltPower.now<3 then
			lib.ComboSet(3)
		end
	end)
	lib.SetAuraFunction("DivPurp","OnFade",function()
		lib.ComboSet(cfg.AltPower.now)
	end)
	lib.AddSpell("SotR",{53600}) -- Shield of the Righteous
	lib.AddAura("SotR",132403,"buff","player") -- Shield of the Righteous
	lib.SetBUFF("SotR")
	lib.SetAuraFunction("SotR","OnApply",function()
		lib.UpdateBUFF(UnitGUID("player"),0)
	end)
	lib.SetAuraFunction("SotR","OnFade",function()
		lib.UpdateBUFF(UnitGUID("player"))
	end)
	
	lib.AddSpell("AS",{31935}) -- Avenger's Shield
	lib.AddSpell("HW",{119072}) -- Holy Wrath
	lib.AddSpell("Cons",{26573}) -- Consecration
	if IsPlayerSpell(157486) then cfg.spells["Cons"].id=159556 end
	lib.AddAura("GC",85416,"buff","player") -- Grand Crusader
	
	
	cfg.talents={
	["SW"]=IsPlayerSpell(171648),
	}
	
	cfg.plistdps = {}
--	table.insert(cfg.plistdps,"Seal")
	table.insert(cfg.plistdps,"BoK")
	table.insert(cfg.plistdps,"BoM")
	table.insert(cfg.plistdps,"SS_noSS")
	table.insert(cfg.plistdps,"HolyA")
	table.insert(cfg.plistdps,"SotR5")
	table.insert(cfg.plistdps,"J_range")
	table.insert(cfg.plistdps,"AS_range")
	table.insert(cfg.plistdps,"CS")
	table.insert(cfg.plistdps,"J")
	if cfg.talents["SW"] then
		table.insert(cfg.plistdps,"HW")
	end
	table.insert(cfg.plistdps,"AS")
	table.insert(cfg.plistdps,"SotR3")
	table.insert(cfg.plistdps,"ES")
	table.insert(cfg.plistdps,"LH")
	table.insert(cfg.plistdps,"HP")
	table.insert(cfg.plistdps,"HoW")
	table.insert(cfg.plistdps,"Cons")
	if not cfg.talents["SW"] then
		table.insert(cfg.plistdps,"HW")
	end
	table.insert(cfg.plistdps,"end")
	
	cfg.plistaoe = {}
	table.insert(cfg.plistaoe,"BoK")
	table.insert(cfg.plistaoe,"BoM")
	table.insert(cfg.plistaoe,"SS_noSS")
	table.insert(cfg.plistaoe,"SotR5")
	table.insert(cfg.plistaoe,"AS_range")
	table.insert(cfg.plistaoe,"AS_GC")
	table.insert(cfg.plistaoe,"J_range")
	table.insert(cfg.plistaoe,"HotR")
	if cfg.talents["SW"] then
		table.insert(cfg.plistaoe,"HW")
	end
	table.insert(cfg.plistaoe,"AS")
	table.insert(cfg.plistaoe,"SotR3")
	table.insert(cfg.plistaoe,"LH")
	table.insert(cfg.plistaoe,"HP")
	table.insert(cfg.plistaoe,"Cons")
	table.insert(cfg.plistaoe,"ES")
	table.insert(cfg.plistaoe,"HoW")
	if not cfg.talents["SW"] then
		table.insert(cfg.plistaoe,"HW")
	end
	table.insert(cfg.plistaoe,"J")
	table.insert(cfg.plistaoe,"end")

	cfg.plist = cfg.plistdps

	cfg.case = {
		["AS_range"] = function()
			if lib.inrange("CS") then return nil end
			return lib.SimpleCDCheck("AS")
		end,
		["AS_GC"] = function()
			if lib.GetAura({"GC"})>lib.GetSpellCD("AS") then
				return lib.SimpleCDCheck("AS")
			end
			return nil
		end,
		["SotR5"] = function()
			if cfg.AltPower.now==cfg.AltPower.max or lib.GetAura({"DivPurp"})>0  then
				return lib.SimpleCDCheck("SotR")
			end
			return nil
		end,
		["SotR3"] = function()
			if cfg.AltPower.now>=3 or lib.GetAura({"DivPurp"})>0 then
				return lib.SimpleCDCheck("SotR")
			end
			return nil
		end
	}
	
	cfg.spells_aoe={"HotR"}
	cfg.spells_single={"CS"}
	return true
end

lib.classes["PALADIN"][3] = function () --Retribution
	lib.SetAltPower(SPELL_POWER_HOLY_POWER,HOLY_POWER_COST)
	
	lib.AddAura("DivPurp",90174,"buff","player") -- Divine Purpose
	
	lib.AddSpell("Exo",{879}) -- Exorcism
	lib.AddSpell("TV",{157048,85256}) -- Templar's Verdict
	lib.AddAura("FV",157048,"buff","player") -- Final Verdict
	
	lib.AddSpell("DS",{53385}) -- Divine Storm
	lib.AddAura("DC",144595,"buff","player") -- Divine Crusader
	
	lib.AddSpell("GoAK",{86150}) -- Guardian of Ancient Kings 
	lib.AddSpell("Zealotry",{85696}) -- Zealotry
	lib.AddSpell("AW",{31884}) -- Avenging Wrath
	
	lib.AddAura("AoW",59578,"buff","player") -- The Art of War
	lib.AddAura("Inq",84963,"buff","player") -- Inquisition
	lib.AddAura("J",53657,"buff","player") -- Judgements of the Pure
	lib.AddAura("Zealotry",85696,"buff","player") -- Zealotry
	lib.AddAura("AW",31884,"buff","player") -- Avenging Wrath
	
	cfg.set["T13"]={}
	cfg.set["T13"]={76875,78770,78675,76876,78693,78788,76877,78712,78807,76878,78742,78837}
	
	cfg.plistdps = {}
--	table.insert(cfg.plistdps,"Seal")
--	table.insert(cfg.plistdps,"Inq")
	table.insert(cfg.plistdps,"AW_buff")
	table.insert(cfg.plistdps,"BoM")
	table.insert(cfg.plistdps,"BoK")
	table.insert(cfg.plistdps,"DS_buffed")
	table.insert(cfg.plistdps,"TV5")
	table.insert(cfg.plistdps,"SS_noSS")
	table.insert(cfg.plistdps,"HolyA")
	table.insert(cfg.plistdps,"ES")
	table.insert(cfg.plistdps,"LH")
	table.insert(cfg.plistdps,"HP")
	table.insert(cfg.plistdps,"HoW")
	table.insert(cfg.plistdps,"J_range")
	table.insert(cfg.plistdps,"Exo_range")
	table.insert(cfg.plistdps,"CS")
	table.insert(cfg.plistdps,"J")
	table.insert(cfg.plistdps,"Exo")
	table.insert(cfg.plistdps,"DS_DC")
	table.insert(cfg.plistdps,"TV3")
	
	
	--[[table.insert(cfg.plistdps,"GoAK")
	table.insert(cfg.plistdps,"Zealotry")
	table.insert(cfg.plistdps,"AW")
	table.insert(cfg.plistdps,"CS_no3")
	table.insert(cfg.plistdps,"JT13_noZealotry")
	
	table.insert(cfg.plistdps,"J")
	table.insert(cfg.plistdps,"HW")
	table.insert(cfg.plistdps,"Cons_mana")
	table.insert(cfg.plistdps,"Plea")]]
	table.insert(cfg.plistdps,"end")
	
	cfg.plistaoe = {}
	table.insert(cfg.plistaoe,"BoM")
	table.insert(cfg.plistaoe,"BoK")
	table.insert(cfg.plistaoe,"Inq")
	table.insert(cfg.plistaoe,"DS")
	table.insert(cfg.plistaoe,"LH")
	table.insert(cfg.plistaoe,"HoW")
	table.insert(cfg.plistaoe,"Exo")
	table.insert(cfg.plistaoe,"HotR")
	table.insert(cfg.plistaoe,"J")
	table.insert(cfg.plistaoe,"DS_34")
	table.insert(cfg.plistaoe,"Plea")
	table.insert(cfg.plistaoe,"end")

	cfg.plist = cfg.plistdps

	cfg.case = {
		--[[["HoW"] = function()
			if cfg.health<=20 or lib.GetAura({"AW"})>lib.GetSpellCD("HoW") then
				return lib.SimpleCDCheck("HoW")
			end
			return nil
		end,]]
		["AW_buff"] = function()
			if lib.GetAuras("Heroism")>lib.GetSpellCD("AW") then
				return lib.SimpleCDCheck("AW")
			end
			return nil
		end,
		["TV5"] = function()
			if cfg.AltPower.now==cfg.AltPower.max or lib.GetAura({"DivPurp"})>lib.GetSpellCD("TV") then
				return lib.SimpleCDCheck("TV")
			end
			return nil
		end,
		["DS_DC"] = function()
			if lib.GetAura({"DC"})>lib.GetSpellCD("DS") then
				return lib.SimpleCDCheck("DS")
			end
			return nil
		end,
		["DS_buffed"] = function()
			if lib.GetAura({"DC"})>lib.GetSpellCD("DS") and lib.GetAura({"FV"})>lib.GetSpellCD("DS") then
				if (cfg.AltPower.now>=3 or lib.GetAura({"DivPurp"})>lib.GetSpellCD("DS")) then
					return lib.SimpleCDCheck("DS")
				end
			end
			return nil
		end,
		["DS"] = function()
			if cfg.AltPower.now==cfg.AltPower.max or lib.GetAura({"DivPurp"})>lib.GetSpellCD("DS") then
				return lib.SimpleCDCheck("DS")
			end
			return nil
		end,
		["TV3"] = function()
			if cfg.AltPower.now>=3 or lib.GetAura({"DivPurp"})>lib.GetSpellCD("TV") then
				return lib.SimpleCDCheck("TV")
			end
			return nil
		end,
		["DS_34"] = function()
			if cfg.AltPower.now>=3 or lib.GetAura({"DivPurp"})>lib.GetSpellCD("DS") then
				return lib.SimpleCDCheck("DS")
			end
			return nil
		end,
		["JT13_noZealotry"] = function()
			if lib.SetBonus("T13")>=1 and cfg.AltPower.now<3 and lib.GetSpellCD("J")>lib.GetAura({"Zealotry"}) then
				return lib.SimpleCDCheck("J")
			end
			return nil
		end,
		
		["Exo_range"] = function()
			if lib.inrange("CS") then return nil end
			return lib.SimpleCDCheck("Exo")
		end,
		["GoAK"] = function()
			if lib.GetSpellCD("Zealotry")<10 and cfg.target=="worldboss" then 
				return lib.SimpleCDCheck("GoAK")
			end
			return nil
		end,
		["Zealotry"] = function()
			if (cfg.AltPower.now==3 or lib.GetAura({"DivPurp"})>lib.GetSpellCD("Zealotry")) and  cfg.target=="worldboss" then
				return lib.SimpleCDCheck("Zealotry",(lib.GetSpellCD("GoAK")-290))
			end
			return nil
		end,
		["AW"] = function()
			if lib.GetAura({"Zealotry"})>lib.GetSpellCD("AW") and cfg.target=="worldboss" then
				return lib.SimpleCDCheck("AW")
			end
			return nil
		end,
		["CS_no5"] = function()
			if cfg.AltPower.now<cfg.AltPower.max then
				return lib.SimpleCDCheck("CS")
			end
			return nil
		end,
		["J_noJ"] = function()
			return lib.SimpleCDCheck("J",lib.GetAura({"J"})-1)
		end,
		["Inq"] = function()
			if cfg.AltPower.now>0 or lib.GetAura({"DivPurp"})>lib.GetSpellCD("Inq") then
				return lib.SimpleCDCheck("Inq",lib.GetAura({"Inq"})-2)
			end
			return nil
		end,
		["Exo_AoW"] = function()
			if lib.GetAura({"AoW"})>lib.GetSpellCD("Exo") then
				return lib.SimpleCDCheck("Exo")
			end
			return nil
		end,
		["Plea"] = function()
			if cfg.Power.real<2*lib.GetSpellCost("CS") then
				return lib.SimpleCDCheck("Plea")
			end
			return nil
		end,
	}
	cfg.spells_aoe={"HotR"}
	cfg.spells_single={"CS","TV"}
	return true
end

lib.classevents["PALADIN"] = function()
	
	lib.SetAltPower(SPELL_POWER_HOLY_POWER,HOLY_POWER_COST,nil,function()
	if lib.GetAura({"DivPurp"})>0 and cfg.AltPower.now<3 then
		lib.ComboSet(3)
	end
	end)
	lib.AddAura("DivPurp",90174,"buff","player") -- Divine Purpose
	lib.SetAuraFunction("DivPurp","OnApply",function()
		if cfg.AltPower.now<3 then
			lib.ComboSet(3)
		end
	end)
	lib.SetAuraFunction("DivPurp","OnFade",function()
		lib.ComboSet(cfg.AltPower.now)
	end)
	
	lib.AddSpell("ES",{114157}) -- Execution Sentence
	lib.AddSpell("LH",{114158}) -- Light's Hammer
	lib.AddSpell("HP",{114165}) -- Holy Prism
	lib.AddSpell("HotR",{53595}) -- Hammer of the Righteous
	lib.AddSpell("CS",{35395}) -- Crusader Strike
	lib.AddSpell("HL",{635}) -- Holy Light
	cfg.gcd = "HL"

	lib.AddSpell("J",{20271}) -- Judgement
	lib.AddSpell("HoW",{24275}) -- Hammer of Wrath
	if IsPlayerSpell(157496) then cfg.spells["HoW"].id=158392 end

	lib.AddSpell("BoK",{20217}) -- Blessing of Kings
	lib.AddAura("BoK",20217,"buff","player") -- Blessing of Kings
	lib.AddAuras("Stats",{20217,1126,159988,160017,90363,160077,115921,116781},"buff") -- Stats
	lib.AddSpell("BoM",{19740}) -- Blessing of Might
	lib.AddAura("BoM",19740,"buff","player") -- Blessing of Might
	lib.AddAuras("Mastery",{19740,155522,24907,93435,160039,160073,128997,116956},"buff") -- Mastery
	lib.AddAuras("Seal",{20165,20154,31801,20164},"buff","player") -- Seals
	
	lib.AddSpell("SS",{20925}) -- Sacred Shield
	lib.AddAura("SS",20925,"buff","player") -- Sacred Shield
	lib.AddSpell("HolyA",{105809}) -- Holy Avenger


	lib.CD = function()
		lib.CDadd("AW")
		lib.CDadd("HolyA")
		lib.CDadd("ES")
		lib.CDadd("LH")
		lib.CDadd("HP")
		lib.CDadd("SS")
	end
	
	function Heddclassevents.UNIT_HEALTH_FREQUENT(unit)
		if unit=="target" then
			lib.UpdateSpell("HoW")
		end
	end	
	
	cfg.mode = "dps"
	
	cfg.case["BoM"] = function ()
		if lib.GetAura({"BoK"})>lib.GetSpellCD("BoM") then return nil end
		return lib.SimpleCDCheck("BoM",lib.GetAuras("Mastery"))
	end
	
	cfg.case["SS_noSS"] = function ()
		return lib.SimpleCDCheck("SS",lib.GetAura({"SS"}))
	end
	
	cfg.case["BoK"] = function ()
		if lib.GetAura({"BoM"})>lib.GetSpellCD("BoK") then return nil end
		return lib.SimpleCDCheck("BoK",lib.GetAuras("Stats"))
	end
	
	cfg.case["J_range"] = function()
		if lib.inrange("CS") then return nil end
		return lib.SimpleCDCheck("J")
	end
	
	lib.onclick = function()
		if cfg.mode == "dps" then
			cfg.mode = "aoe"
			cfg.plist=cfg.plistaoe
			cfg.Update=true
		else
			cfg.mode = "dps"
			cfg.plist=cfg.plistdps
			cfg.Update=true
		end
		
	end
	
	lib.rangecheck=function()
		if lib.inrange("CS") then
			lib.bdcolor(Heddframe.bd,nil)
		elseif lib.inrange("J") then
			lib.bdcolor(Heddframe.bd,{1,1,0,1})
		else
			lib.bdcolor(Heddframe.bd,{1,0,0,1})
		end
	end
	
	
end