-- get the addon namespace
local addon, ns = ...
-- get the config values
local cfg = ns.cfg
-- holder for some lib functions
local lib = _G["HEDD_lib"] or CreateFrame("Frame","HEDD_lib")
ns.lib = lib

lib.UpdateCast = function(spellID)
	cfg.Casting.name, _, _, _, cfg.Casting.caststart, cfg.Casting.castend, _, cfg.Casting.castid = UnitCastingInfo("player")
	if cfg.Casting.name then
		cfg.Casting.iscasting=true
		cfg.Casting.caststart=cfg.Casting.caststart / 1e3
		cfg.Casting.castend=cfg.Casting.castend / 1e3
		cfg.Casting.id=spellID or lib.GetSpellIdbyName(cfg.Casting.name)
		cfg.Casting.cost=lib.GetSpellCost(cfg.id2spell[cfg.Casting.id])
		
		return true
	else
		cfg.Casting.iscasting=nil
		cfg.Casting.cost=0
		cfg.Casting.id=nil
		cfg.Casting.castid=nil
		return false
	end
end

lib.IsCasting = function()
	if cfg.Casting.iscasting and cfg.Casting.castend>cfg.now then
		return true
	else
		return false
	end
end

lib.GetCastingSpell=function()
	if lib.IsCasting() then
		return cfg.id2spell[cfg.Casting.id]
	end
	return nil
end

lib.GetCastingSpellCost=function()
	if lib.IsCasting() then
		return cfg.Casting.cost
	end
	return 0
end

lib.SpellCastingLeft=function(spell)
	if lib.IsCasting() then
		if (not spell) or (spell and cfg.spells[spell] and cfg.spells[spell].name==cfg.Casting.name) then
			return (cfg.Casting.castend-cfg.now)
		end
	end
	return 0
end

lib.SpellCasting=function(spell)
	if lib.IsCasting() then
		if (not spell) or (spell and cfg.spells[spell] and cfg.spells[spell].id==cfg.Casting.id) then
			return true
		else
			return false
		end
	end
	return false
end

lib.SaveSpell = function(spellID)
	cfg.spellcast[spellID]=cfg.now
	cfg.lastspell2=cfg.lastspell
	cfg.lastspell=spellID
	cfg.lastspell_time=cfg.now
end

lib.IsLastSpell = function(spell)
	if cfg.lastspell and cfg.spells[spell] and cfg.lastspell==cfg.spells[spell].id then
		return true
	end
	return nil
end

lib.GetLastSpell = function (spells)
	for _,cspell in ipairs(spells) do
		if cfg.spells[cspell] and cfg.spellcast[cfg.spells[cspell].id] then
			if cfg.now<(cfg.spellcast[cfg.spells[cspell].id]-cfg.spells[cspell].castingTime+1) then
				return true
			end
		end
	end
	return nil
end